/////////////////////////////////////////////////////////////////////////////
// @doc ToolTipAdapter
// @module ToolTipAdapter.Java | Implementation of the <c ToolTipAdapter> class.
// 
// Rosa2000 Applet<tm>
// <nl>Copyright <cp> 1999, 2000, DM Solutions Group Inc. All rights reserved.
// 
// Author:  Guy Parent
//
// $Id: ToolTipAdapter.java,v 1.3 2000/04/18 23:00:12 daniel Exp $
// 
/////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1999, 2000, DM Solutions Goup Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a
// copy of this software and associated documentation files (the "Software"),
// to deal in the Software without restriction, including without limitation
// the rights to use, copy, modify, merge, publish, distribute, sublicense,
// and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
// 
// The above copyright notice and this permission notice shall be included
// in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
// THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
// FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
// DEALINGS IN THE SOFTWARE.
/////////////////////////////////////////////////////////////////////////////
// $Log: ToolTipAdapter.java,v $
// Revision 1.3  2000/04/18 23:00:12  daniel
// Moved ToolTipButton and ToolTipWin to separate files
//
// Revision 1.2  2000/02/04 15:02:33  gparent
// Added doccumentation.
//
// Revision 1.1  2000/01/28 20:16:30  daniel
// Initial Revision
//
/////////////////////////////////////////////////////////////////////////////


import java.awt.event.MouseAdapter;
import java.applet.Applet;

import java.awt.Canvas;

/**
 * Not implented yet.
 */
public abstract class ToolTipAdapter extends MouseAdapter 
{ 

    protected Rosa2000 m_applet = null;
    
    public ToolTipAdapter( Rosa2000 applet )
    {
        m_applet = applet;
    }
    
    Canvas m_ToolTipWin = null;

    /** * getToolTip will be implemented to return the correct string */ 
    public abstract String getToolTip(java.awt.event.MouseEvent e); 
    
    /** * mouseClicked method comment. */ 
    public void mouseEntered(java.awt.event.MouseEvent e) 
    {   
        // check for right click 
            // call to derived class to provide text 
            String textToDisplay = getToolTip(e); 
            if (textToDisplay == null || textToDisplay.length() == 0) 
                return; // we are done 

            // Set the text in the status bar.
            m_applet.showStatus( textToDisplay );
            
            
/*
    Try to find an other algo.      
            // put it in the popup 
            int offset = e.getComponent().getBounds().getSize().height; 
            java.awt.PopupMenu popup = new java.awt.PopupMenu(); 
            popup.add(new java.awt.MenuItem(textToDisplay)); 
    
            e.getComponent().add(popup); 
            popup.show(e.getComponent(), 0, offset); 
*/
    }    
} 

